# Inspired by livna 
# stuff to be implemented externally:
Source10: kmodtool
%define   kmodtool bash %{SOURCE10}
# end stuff to be ...

# hardcode for now:
%{!?kversion: %define kversion 2.6.21-1.3228.fc7}

%define kmod_name ipw3945 
%define kverrel %(%{kmodtool} verrel %{?kversion} 2>/dev/null)

%define upvar ""
%ifarch i686
%define paevar PAE
%endif
%ifarch i686 x86_64
#disabled for now
#define xenvar xen
%endif
%ifarch x86_64 ppc
%define kdumpvar kdump
%endif

%{!?kvariants: %define kvariants %{?upvar} %{?smpvar} %{?paevar} %{?xenvar} %{?kdumpvar}}

Summary: Intel PRO/Wireless 3945ABG/3945BG driver for Linux
Name: ipw3945-kmod
Epoch: 1
Version: 1.2.1
Release: 3.%(echo %{kverrel} | tr - _)
License: GPL/BSD
Group: System Environment/Kernel
URL: http://ipw3945.sourceforge.net/
Source0: http://prdownloads.sourceforge.net/ipw3945/%{kmod_name}-%{version}.tgz
Patch0: http://ipw3945.sourceforge.net/patches/ipw3945-1.2.1-inta-fix.patch
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

Requires: ipw3945-kmod-common = 1:%{version}

ExclusiveArch: i686 x86_64

%description
This package contains kernel drivers for the Intel PRO/Wireless 3945.


# magic hidden here:
%{expand:%(%{kmodtool} rpmtemplate %{kmod_name} %{kverrel} %{kvariants} 2>/dev/null)}

%description 
This package contains kernel drivers for ipw3945.
This RPM contains a binary Linux kernel module build for %{kernel}.

%prep
%setup -q -c
pushd ipw3945-%{version}
grep -rl '<net/ieee80211.h>' . | xargs perl -pi -e's,<net/ieee80211.h>,"net/ieee80211.h",'
perl -pi -e's,/sbin/depmod,:,g' Makefile
%patch0 -p1 -b .inta
popd

## kwizart - enabled monitor mode.
grep -rl '# CONFIG_IPW3945_MONITOR=y' ipw3945-%{version}/Makefile \
| xargs perl -pi -e's,# CONFIG_IPW3945_MONITOR=y,CONFIG_IPW3945_MONITOR=y,'
grep -rl '# CONFIG_IEEE80211_RADIOTAP=y' ipw3945-%{version}/Makefile \
| xargs perl -pi -e's,# CONFIG_IEEE80211_RADIOTAP=y,CONFIG_IEEE80211_RADIOTAP=y,'
grep -rl '# CONFIG_IPW3945_PROMISCUOUS=y' ipw3945-%{version}/Makefile \
| xargs perl -pi -e's,# CONFIG_IPW3945_PROMISCUOUS=y,CONFIG_IPW3945_PROMISCUOUS=y,'
grep -rl '# CONFIG_IPW3945_SIM_RX=y' ipw3945-%{version}/Makefile \
| xargs perl -pi -e's,# CONFIG_IPW3945_SIM_RX=y,CONFIG_IPW3945_SIM_RX=y,'

for kvariant in %{kvariants}; do
    cp -a ipw3945-%{version} _kmod_build_$kvariant
done


%build

for kvariant in %{kvariants} ; do
pushd _kmod_build_$kvariant
make \
  KSRC=%{_usrsrc}/kernels/%{kverrel}${kvariant:+-$kvariant}-%{_target_cpu} \
  IEEE80211_IGNORE_DUPLICATE=y \
  KVER=%{kverrel}${kvariant} \
  KMISC=/lib/modules/%{kverrel}${kvariant}/extra/%{kmod_name}
popd
done

# %endif

%install
rm -rf %{buildroot}
for kvariant in %{kvariants}
do
mkdir -p $RPM_BUILD_ROOT/lib/modules/%{kverrel}${kvariant}/extra/%{kmod_name}/
install -D -m 0644 _kmod_build_$kvariant/*.ko $RPM_BUILD_ROOT/lib/modules/%{kverrel}${kvariant}/extra/%{kmod_name}/
done
chmod u+x $RPM_BUILD_ROOT/lib/modules/*/extra/%{kmod_name}/*

%clean
rm -rf %{buildroot}

%Changelog
* Mon May 21 2007 kwizart < kwizart at gmail.com > - 1:1.2.1-3
- livna submit

* Mon May 21 2007 kwizart < kwizart at gmail.com > - 1:1.2.1-2
- Add patch inta

* Wed May  2 2007 kwizart < kwizart at gmail.com > - 1:1.2.1-1
- Update to 1.2.1

* Sat Jan 06 2007 kwizart < kwizart at gmail.com > - 1:1.2.0-2
- Fix Requires ipw3945-kmod-common
- Drop ieee80211 reference

* Sat Jan 06 2007 kwizart < kwizart at gmail.com > - 1:1.2.0-1
- Update to 1.2.0
- Using Epoch

* Thu Dec 28 2006 kwizart < kwizart at gmail.com > - 1.1.3-1
- Update to 1.1.3

* Sat Nov 25 2006 kwizart < kwizart at gmail.com > - 1.1.2-1.fc6
- Update to 1.1.2
- Enable Monitor mode.

* Sun Oct 22 2006 kwizart < kwizart at gmail.com > - 1.1.0-3_FC5
- Include linux/config.h is now deprecated. Since kernel 2.6.18-1.2200.fc5

* Sun Aug 27 2006 kwizart < kwizart at gmail.com > - 1.1.0-2_FC5
- Update build (ieee80211 1.2.15)

* Mon Aug 07 2006 kwizart at < fedora-france.org >
- switch to non-atrpms .spec format
- Update to 1.1.0

* Wed Jun 28 2006 Axel Thimm <Axel.Thimm@ATrpms.net>
- Update to 1.1.0-pre2.


